<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<!--
Project:
  glideinWMS

File Version: 
  $Id: factoryLogStatus.html,v 1.15 2011/02/10 21:35:30 parag Exp $

Description:
  Browse the glideinWMS RRDs

  Based on
  javascriptrrd/src/lib/rrdJFlot.html 
   Original repository: http://javascriptrrd.sourceforge.net/
-->

<html>
  
    <script type="text/javascript" src="jslibs/binaryXHR.js"></script>
    <script type="text/javascript" src="jslibs/rrdFile.js"></script>
    <script type="text/javascript" src="jslibs/rrdMultiFile.js"></script>
    <script type="text/javascript" src="jslibs/rrdFilter.js"></script>

    <!-- rrdFlot class needs the following four include files !-->
    <script type="text/javascript" src="jslibs/rrdFlotSupport.js"></script>
    <script type="text/javascript" src="jslibs/rrdFlot.js"></script>
    <script type="text/javascript" src="jslibs/jquery.js"></script>
    <script type="text/javascript" src="jslibs/jquery.flot.js"></script>
    <script type="text/javascript" src="jslibs/jquery.flot.selection.js"></script>

    <script type="text/javascript" src="jslibs/factory_support.js"></script>
  <head>
    <title>Glidein factory status from logs</title>
  </head>

  <body>
    <table width="100%">
    <tr>
     <td><h1 id="title">Glidein factory status from logs</h1>
     <td align="right">
     <SELECT id="destination" style="float:right" onChange="goToDestination(this)" >
<OPTION VALUE="" >Choose a Glidein destination...</OPTION>
<OPTION VALUE="factoryEntryStatusNow.html"> Glidein entry. </OPTION>
<OPTION VALUE="factoryStatusNow.html"> Glidein factory status now. </OPTION>
<OPTION VALUE="factoryStatus.html"> Glidein factory status. </OPTION>
<OPTION VALUE="factoryCompletedStats.html"> Glidein factory completed stats. </OPTION>
<OPTION VALUE="factoryRRDBrowse.html"> Glidein factory browse. </OPTION>
<OPTION VALUE="factoryRRDEntryMatrix.html"> Glidein factory entry matrix. </OPTION>
</SELECT>

    </tr>
    </table>

    <table border=0>
     <tr>
       <th>Entry</th>
       <td valing="middle">
         <select id="entries">
	  <option value="total">total</option>
	 </select>
       </td>
     </tr>
     <tr>
       <th>Info group</th>
       <td valign="middle"><form id="gtypes">
	<input type="radio" name="gtype" value="running" checked>Running
	<input type="radio" name="gtype" value="idle">Idle
	<input type="radio" name="gtype" value="other">Other
	<input type="radio" name="gtype" value="completed">Completed
       </form></td>
     </tr>
     <tr>
      <td colspan=2><button onClick="fname_update()">Update</button><button onClick="showLink()" style="float:right">Link</button></td>
     </tr>
    </table>

    <hr>

    <table id="infotable" border=1>
        <tr><td colspan="21"><b>Javascript needed for this page to work</b></td></tr>
	<tr><td><b>RRD file</b></td><td id="fname" colspan="5">None</td></tr>
    </table>

    <div id="mygraph"></div>

   <hr>
    <p>Powered by
        <a href="http://oss.oetiker.ch/rrdtool/" target="_blank">RRDTool</a>,
        <a href="https://sourceforge.net/projects/javascriptrrd/" target="_blank">JavascriptRRD</a> and                                                                 <a href="http://code.google.com/p/flot/" target="_blank">Flot</a>.
 
    <script type="text/javascript">
	
	  var infoGroupOptions = new Array("running", "idle", "other", "completed");
	  var ENTRY; 

      // Remove the Javascript warning
      document.getElementById("infotable").deleteRow(0);

      // Load the status of the factory
      var factoryQStats=loadFactoryQStats();
      //var entries=getFactoryEntries(factoryQStats);

      var entries=getFactoryEntryGroups(factoryQStats);
      group_map = entries;
      char_count=0;
      groups_starting_idx = 0;
      var entries_processed = 0;

      var ordered_entries_groups = [];
      for(entry in entries) {
          var e = (entries[entry]).toString();
          if (((e.split(",")).length == 1) && (e == entry.toString())){
              ordered_entries_groups[entry] = entries[entry];
              groups_starting_idx++;
          }
      }
      for(entry in entries) {
          var e = (entries[entry]).toString();
          if (((e.split(",")).length > 1) || (e != entry.toString())){
              ordered_entries_groups[entry] = entries[entry];
          }
      }
      entries = ordered_entries_groups;

      var entries_select=document.getElementById("entries");
      var sep1 = new Option("--------------------","-");
      var sep2 = new Option("--------------------","-");
      sep1.disabled = true;
      sep2.disabled = true;
      entries_select.appendChild(sep1);
      var ec_added = 0;
      for (var entry in entries) {
          if (ec_added < groups_starting_idx) {
              entries_select.appendChild(new Option(entries[entry],entries[entry]));
              ec_added++;
          } else {
              if ((ec_added == groups_starting_idx) && (ec_added != 0)){ 
                  entries_select.appendChild(sep2);
              }
              entries_select.appendChild(new Option(entry,entries[entry]));
              ec_added++;
          } 
      }


     // fname, gtype_id and rrd_data are the global variable used by all the functions below
      rrd_data=undefined;
      gtype_id=undefined;
      rrd_group_data=[];
      files_loaded = 0;
	  checkUrl(); 

      function entrylist2groupname(elist) {
          var gname = elist;
          for(var g in group_map) {
              if ((group_map[g] == elist) && (g.toString() != elist)){
                  gname = g;
                  break;
              }
          }
          return gname;
      }

      // This function updates the Web Page with the data from the RRD archive header
      // when a new file is selected
      function update_plot() {
        var gtype_DSs=new Object();
        gtype_DSs['running']=new Array('StatusRunning','EnteredRunning','ExitedRunning','EnteredCompleted','EnteredHeld');
        gtype_DSs['idle']=new Array('StatusIdle','StatusWait','EnteredIdle','ExitedIdle','EnteredWait','ExitedWait','EnteredRunning','EnteredHeld');
        gtype_DSs['other']=new Array('StatusHeld','EnteredHeld','ExitedHeld','EnteredRemoved','EnteredIdle','EnteredRunning')
        gtype_DSs['completed']=new Array('Lasted','CondorLasted','JobsLasted','JobsTerminated','JobsGoodput','Glideins','FailedNr','JobsNr');

        var gtype_formats=new Object();
        gtype_formats['running']={'StatusRunning':{ title: 'Running glideins', label: 'Running', color: "#00f800", checked:true,
                                                    lines: { show: true, fill: true, fillColor:"#00ff00"} },
                                  'EnteredRunning':{title: 'Glidein startup rate', label:'Startup', color: "#008000", yaxis: 2},
                                  'ExitedRunning':{title: 'Glidein termination rate', label:'Termination',color: "#00ffff", yaxis: 2},
                                  'EnteredCompleted':{title: 'Glidein completion rate', label:'Completion', color: "#ffff00", yaxis: 2},
                                  'EnteredHeld':{title: 'Held rate', label:'Held', color: "#ff0000", yaxis: 2}};

        gtype_formats['idle']={'StatusIdle':{ title: 'Idle glideins', label:'Idle', color: "#0000f8", checked:true,
                                              lines: { show: true, fill: true, fillColor:"#0000ff"} },
                               'StatusWait':{ title: 'Waiting glideins', label:'Waiting', color: "#f800f8", checked: true},
                               'EnteredIdle':{title: 'Glidein submission rate', label:'Submission', color: "#00ffff", yaxis: 2},
                               'ExitedIdle':{title: 'Rate out of idle state', label:'Idle out', color: "#000080", yaxis: 2},
                               'EnteredWait':{title: 'Rate into wait state', label:'Wait in', color: "#800080", yaxis: 2},
                               'ExitedWait':{title: 'Rate out of wait state', label:'Wait out', color: "#ff0080", yaxis: 2},
                               'EnteredRunning':{title: 'Rate into running state', label:'Run in', color: "#00c000", yaxis: 2},
                               'EnteredHeld':{title: 'Rate into held state', label:'Held in', color: "#ff0000", yaxis: 2}};

        gtype_formats['other']={'StatusHeld':{ title: 'Held glideins', label:'Abs held', color: "#f80000", checked:true,
                                               lines: { show: true, fill: true, fillColor:"#ff0000"} },
                                'EnteredHeld':{title: 'Glidein held rate', label:'Held rate', color: "#800000", yaxis: 2},
                                'ExitedHeld':{title: 'Glidein release rate', label:'Release', color: "#ff8000", yaxis: 2},
                                'EnteredRemoved':{title: 'Glidein removal rate', label: 'Removal', color: "#ffff00", yaxis: 2},
                                'EnteredIdle':{title: 'Rate into idle state', label: 'Idle in', color: "#0000ff", yaxis: 2},
                                'EnteredRunning':{title: 'Rate into running state', label: 'Run in', color: "#00ff00", yaxis: 2}};

        gtype_formats['completed']={'Lasted':{ title: 'Glideins wallclock time', label:'Lasted', color: "#00f8f8", checked:true,
                                               lines: { show: true, fill: true, fillColor:"#00ffff"} },
                                    'CondorLasted':{ title: 'Condor within glideins wallclock time', label:'Condor Lasted', color: "#008080", checked:false,
                                               lines: { show: true, fill: true, fillColor:"#008484"} },
                                    'JobsLasted':{ title: 'User jobs wallclock time', label:'Jobs Lasted', color: "#0000f8", checked:false,
                                               lines: { show: true, fill: true, fillColor:"#0000ff"} },
                                    'JobsTerminated':{ title: 'Terminated user jobs wallclock time', label:'Jobs Terminated', color: "#008000", checked:true,
                                               lines: { show: true, fill: true, fillColor:"#008400"} },
                                    'JobsGoodput':{ title: 'User jobs goodput', label:'Jobs Goodput', color: "#00c000", checked:false,
                                               lines: { show: true, fill: true, fillColor:"#00c400"} },
                                    'Glideins':{title: 'Number of terminated glideins', label:'Glideins Nr', color: "#000000", yaxis: 2, checked:false},
                                    'FailedNr':{title: 'Number of glideins failing validation', label:'Failed Nr', color: "#ff0000", yaxis: 2, checked:false},
                                    'JobsNr':{title: 'Number of user jobs executed', label: 'Jobs Nr', color: "#c0ff00", yaxis: 2, checked:false}};

        var rrd_data1 = undefined;
        if (rrd_group_data.length == 0) {
            rrd_data1=new RRDFilterDS(rrd_data,gtype_DSs[gtype_id]);
            // the rrdFlot object creates and handles the graph
        } else {
            var rrd_data_sum = new RRDFileSum(rrd_group_data, false);
            rrd_data1=new RRDFilterDS(rrd_data_sum,gtype_DSs[gtype_id]);
        }

        // the rrdFlot object creates and handles the graph
        var f=new rrdFlot("mygraph",rrd_data1,null,gtype_formats[gtype_id]);

        // Finally, update the files loaded so far
        files_loaded = files_loaded + 1;
        var total_file_to_load = fname.split(",").length
        if (files_loaded < total_file_to_load) {
            document.getElementById("fname").firstChild.data="Loaded files " + files_loaded + "/" + total_file_to_load;
        }
        else {
            document.getElementById("fname").firstChild.data="Loaded files " + files_loaded + "/" + total_file_to_load + ": " + fname;
        }

      }

      // This is the callback function that,
      // given a binary file object,
      // verifies that it is a valid RRD archive
      // and performs the update of the Web page
      function update_plot_handler(bf) {
          var i_rrd_data=undefined;
          try {
            var i_rrd_data=new RRDFile(bf);            
          } catch(err) {
            alert("File "+fname+" is not a valid RRD archive!");
          }
          if (i_rrd_data!=undefined) {
            rrd_data=i_rrd_data;
            update_plot()
          }
      }

      function update_grouped_plot_handler(bf) {
          var i_rrd_data=undefined;
          var idx = 0;
          if (rrd_group_data != undefined) {
            idx = rrd_group_data.length;
          } else {
            rrd_group_data = [];
          }

          try {
            var i_rrd_data=new RRDFile(bf);            
          } catch(err) {
            alert("File "+fname+" is not a valid RRD archive!");
          }
          if (i_rrd_data!=undefined) {
            rrd_group_data[idx] = new Array(); 
            rrd_group_data[idx] = i_rrd_data;
            update_plot()
          }
      }


      // this function is invoked when the RRD file name changes
      function fname_update() {
        rrd_group_data=[];
        rrd_data=undefined;
        files_loaded=0;

        var entry_name="";
        gtype_id=undefined;

        var entries_obj=document.getElementById("entries")
        entry_name=entries_obj.options[entries_obj.selectedIndex].value;

        var gtypes_obj=document.getElementById("gtypes");
        for (var i in gtypes_obj.gtype) {
         var gtype=gtypes_obj.gtype[i];
         if (gtype.checked==true) {
  	   gtype_id=gtype.value;
         }
        }

        if ((gtype_id=='running') || (gtype_id=='idle') || (gtype_id=='other')) {
          rrd_fname="Log_Counts";
        } else if (gtype_id=='completed') {
          rrd_fname="Log_Completed";
        } else {
          alert("Unknown gtype_id "+gtype_id); // should never enter here
          rrd_fname=none;
        }

        if (entry_name=="total") {
          fname="total/"+rrd_fname+".rrd";
        } else {
          fname="entry_"+entry_name+"/total/"+rrd_fname+".rrd";
        }

        if ( (entry_name == "total") || (((entry_name.split(",")).length == 1) && (entry_name == entrylist2groupname(entry_name.split(",")))) ){
          //document.getElementById("fname").firstChild.data="Loading "+fname;
          document.getElementById("fname").firstChild.data="Loaded files " + files_loaded + "/" + fname.split(",").length;
          try {
            FetchBinaryURLAsync(fname,update_plot_handler);
          } catch (err) {
             alert("Failed loading "+fname+"\n"+err);
          }
        } else {
          var en_array = entry_name.split(",");
          fname = "";
          for (var i=0; i<en_array.length; i++) {
              if (i == 0) {
                  fname="entry_"+en_array[i]+"/total/"+rrd_fname+".rrd";
              } else {
                  fname=fname+",entry_"+en_array[i]+"/total/"+rrd_fname+".rrd";
              }
          }
          //document.getElementById("fname").firstChild.data="Loading " + fname;
          document.getElementById("fname").firstChild.data="Loaded files " + files_loaded + "/" + fname.split(",").length;

          for (var i=0; i<en_array.length; i++) {
            //alert("GROUP SELECTED with entry: " + en_array[i]);
            var fn = "entry_"+en_array[i]+"/total/"+rrd_fname+".rrd"; 
            try {
              FetchBinaryURLAsync(fn,update_grouped_plot_handler);
            } catch (err) {
               alert("Failed loading "+fn+"\n"+err);
            }
          }
        }
      }
	/* Function to read from the url any parameters the user has specified. */
	function checkUrl()
	{
		var url = window.location.search;
		parameterArry = new Array("entry", "infoGroup"); 
		groups = new Array("CMST1", "CMS", "CMST2", "US", "CMST3", "HCC");
		group = 0;  
		var entrySpec; 
		var infoGroupSpec;
		urlValid = 0; 
		paramSpecArry = new Array(); 
		if(url)
		{
			url = url.substring(1);
			urlSplit = url.split('&'); 
			i = 0; 
			while(i < urlSplit.length)
			{ 
				equalSplit = urlSplit[i].split('='); 
				if(equalSplit[0] == parameterArry[i])
				{
					paramSpecArry[i] = equalSplit[1];
				}
				i++; 
			}
		}
		for(i = 0; i< paramSpecArry.length; i++)
		{
			counter = 2; 
			if(i == 0)
			{
				for(entry in entries)
				{
					if(entry == paramSpecArry[0])
					{
						ENTRY = paramSpecArry[0]; 
						urlValid = 1; 
						for(j = 0; j< groups.length; j++)
						{
							if(entry == groups[j])
							{
								document.getElementById("entries").selectedIndex = counter + 1; 
								group = 1;
								break;  
							}	
						}
						if(!group)
						{
							document.getElementById("entries").selectedIndex = counter; 
						}
						break;
					} 
					else if("total" == 	paramSpecArry[0])
					{
						urlValid = 1; 
						document.getElementById("entries").selectedIndex = 0; 
						break;  	
					}
					counter++; 
				}
			}
			else if(i == 1)
			{
				child = 1; 
				for(i = 0; i< infoGroupOptions.length; i++)
				{
					if(infoGroupOptions[i] == paramSpecArry[1])
					{
						document.getElementById("gtypes").childNodes[child].checked = true;
						urlValid = 1; 
					}
					child+=2;	
				}
			}
		}
		if(urlValid)
		{
			fname_update();
		}
	}
	/* Function to show link for current options. */
	function showLink()
	{
		constructed = document.URL.split('?');
		entriesTable = document.getElementById("entries"); 
		var specifiedEntry;
		var specifiedGOption; 
		/* Find the current entry specified. */
		for(i = 0; i < entriesTable.options.length; i++)
		{
			if(entriesTable.options[i].selected == true)
			{
				specifiedEntry = entriesTable.options[i].text; 	
			}
		}
		gOptionTable = document.getElementById("gtypes");
		j = 0;  
		/* Find the current group option specified. */
		for(i = 1; i< gOptionTable.childNodes.length; i+=2)
		{
			if(gOptionTable.childNodes[i].checked == true)
			{
				specifiedGOption = infoGroupOptions[j];
			}
			j++; 	
		}
		constructed = constructed[0] + "?entry=" + specifiedEntry + "&infoGroup=" + specifiedGOption; 
		document.location.href = constructed; 
	}
	function goToDestination(option)
	{
		if(option.value != "factoryStatusNow.html" && option.value != "factoryRRDEntryMatrix.html" && ENTRY)
		{
			document.location.href = option.value + "?entry=" + ENTRY; 
		}
		else
		{
			document.location.href = option.value; 
		}
		document.getElementById("destination").selectedIndex = 0; 
	}
    </script>
  </body>
</html>
